#include <P16F648A.h>
#include <P16F648A_bits.h>
#include <PortBits.h>
#include <datalib.h>
#include <delays.h>

#define APROCFREQ 10000000

#define BITSIZE 14
#define BOOTADDRESS 0
#define FIRSTRAM 0x20
#define LASTRAM 0x1FF
#define HASOSCCAL 0
#define nPAGESRAM 4
#define nPAGESROM 2
//
// Header file - should be included in all C files used within the program
// This file is created automatically and should not be changed
//

//
// Functions
//
void UserInitialise();			// Your initialisation code
void UserInterrupt();			// Your interrupt code
void UserLoop();			// your Main loop code


#define SimpButnCopy 2
#pragma asmline _SimpButnCopy=2
#define PortInnCopy 1
#pragma asmline _PortInnCopy=1
#define PortOutnCopy 4
// **********
//
// Data EEPROM
//
// **********
#define EEPROMUsed 1
#define EEPROMIntUsed 1
#define ReadAtInit 1
#define ReadInitAddr 0
// **********
//
// Wait for W milli-seconds
//
// **********
#define WaitWmUsed 1
// **********
//
// Timer 2
//
// **********
#define Tmr2Used 1
#define T2_Post 8
#define T2_Pre 4
#define T2_En 0
// **********
//
// Timer 1
//
// **********
#define Tmr1Used 1
#define EnTimer1 1
#define T1_UseOsc 1
#define SyncT1Inp 1
#define EnT1Osc 0
#define T1_PSD 8
// **********
//
// Compare Module 1
//
// **********
#define Comp1Used 1
#define CompareMode1 ClearTMR1
#define InitCV1 62500
#define Compare1Port PORTB
#define Compare1Bit 3
// **********
//
// Simple Switch
//
// **********
#define SimpButUsed 1
#pragma asmline _SimpButUsed=1
#define SimpBut1Used 1
#pragma asmline _SimpBut1Used=1
#pragma asmline _SBPress1Used=1
#pragma asmline _SBPress1Flag=Flag1
#pragma asmline _SBPress1FlagBit=0
#define SBPress1Used 1
#define SBPress1Flag Flag1
#define SBPress1FlagBit 0
void PressSw2();
#define InitialDelay1 500
#pragma asmline _InitialDelay1=500
#define RepDelay1 250
#pragma asmline _RepDelay1=250
#define Debounce1 60
#pragma asmline _Debounce1=60
#define EnableRepeat1 0
#pragma asmline _EnableRepeat1=0
#define Invert1 0
#pragma asmline _Invert1=0
#define SBIn1Port PORTB
#define SBIn1Bit 6
#pragma asmline _SBIn1Port=PORTB
#pragma asmline _SBIn1Bit=6
// **********
//
// Timer 0
//
// **********
#define Tmr0Used 1
void SBT0Of();
#define UsePS 1
#define PSD 4
#define CRE 1
#define UseOsc 1
// **********
//
// Simple Switch
//
// **********
#define SimpBut0Used 1
#pragma asmline _SimpBut0Used=1
#pragma asmline _SBRelease0Used=1
#pragma asmline _SBRelease0Flag=Flag1
#pragma asmline _SBRelease0FlagBit=1
#define SBRelease0Used 1
#define SBRelease0Flag Flag1
#define SBRelease0FlagBit 1
void PressSw1();
#define InitialDelay0 500
#pragma asmline _InitialDelay0=500
#define RepDelay0 250
#pragma asmline _RepDelay0=250
#define Debounce0 60
#pragma asmline _Debounce0=60
#define EnableRepeat0 0
#pragma asmline _EnableRepeat0=0
#define Invert0 0
#pragma asmline _Invert0=0
#define SBIn0Port PORTB
#define SBIn0Bit 7
#pragma asmline _SBIn0Port=PORTB
#pragma asmline _SBIn0Bit=7
// **********
//
// Port Input
//
// **********
#define PortInUsed 1
#pragma asmline _PortInUsed=1
#define PortIn0Used 1
#pragma asmline _PortIn0Used=1
#define In0Port PORTA
#define In0Bit 4
#pragma asmline _In0Port=PORTA
#pragma asmline _In0Bit=4
// **********
//
// Port Driver
//
// **********
#define PortOutUsed 1
#define PortOut3Used 1
#define InitialValue3 0
#define Out3Port PORTA
#define Out3Bit 3
// **********
//
// Port Driver
//
// **********
#define PortOut2Used 1
#define InitialValue2 0
#define Out2Port PORTA
#define Out2Bit 2
// **********
//
// Port Driver
//
// **********
#define PortOut1Used 1
#define InitialValue1 0
#define Out1Port PORTA
#define Out1Bit 1
// **********
//
// Port Driver
//
// **********
#define PortOut0Used 1
#define InitialValue0 0
#define Out0Port PORTA
#define Out0Bit 0
// **********
//
// Interrupt Driven Serial Interface (62x)
//
// **********
#define SerInt62xUsed 1
#pragma asmline _SerInt62xUsed=1
#define SerInt62xIntUsed 1
#pragma asmline _SerInt62xIntUsed=1
#pragma asmline _RxByteUsed=1
#pragma asmline _RxByteFlag=Flag1
#pragma asmline _RxByteFlagBit=2
#define RxByteUsed 1
#define RxByteFlag Flag1
#define RxByteFlagBit 2
void GetRx();
#define SERINTRATE 2400
#pragma asmline _SERINTRATE=2400
#define USEXON 1
#pragma asmline _USEXON=1
#define RXBUFSZ 32
#pragma asmline _RXBUFSZ=32
#define TXBUFSZ 8
#pragma asmline _TXBUFSZ=8
#define RxPort PORTB
#define RxBit 1
#pragma asmline _RxPort=PORTB
#pragma asmline _RxBit=1
#define TxPort PORTB
#define TxBit 2
#pragma asmline _TxPort=PORTB
#pragma asmline _TxBit=2

// **********
//
// Application Designer Variables
//
// **********
extern unsigned char register Flag1;


// Defines specified by 1 or more elements

