// ?????????
// WIZ-C Ver12?  060823

// CCP1 compare mode 10MHz * 1/4 * 1/8 = 312500Hz; t = 3.2us  312500 / 62500 = 5Hz
// CCPR1 = 62500
// TIMER2 10MHz x 1/4 * 1/4 * 1/8

#include "F:\\___CQWORK\\_WizC12Std\\109-2\\DrArm_Auto.h"
#include <ctype.h>
#include <stdlib.h>
#include <strings.h>
#include "..\\def16f648a.h"
#include "..\\Common\\CommFunc.h"		// ????


// ?????????????????? HS BOD ON
#__config _LVP_OFF&_HS_OSC&_WDT_OFF&_CP_OFF&_BODEN_ON&_PWRTE_ON&_MCLRE_ON

#define POWER_ON  PA.B1 = 1			// ???????????
#define POWER_OFF PA.B1 = 0			// ???????????
#define ALM_ON    PA.B2 = 1 		// ???????????
#define ALM_OFF   PA.B2 = 0 		// ?????????????
#define LED_ON    PA.B0 = 1 		// ????????
#define LED_OFF   PA.B0 = 0 		// ????????
#define LED2_ON   PA.B3 = 0 		// ??????2??(???)
#define LED2_OFF  PA.B3 = 1 		// ??????2??(???)


void Pon(void);
void Poff(void);
void SerCmdExec(void);
void IrCmdExec(BYTE cmd);

bool flag = false;
signed char BlinkCnt = 2;//-1;
bool LedSts = false;
bool Flag1 = false;
bool KeySense;
BYTE KeyCode = 0;
BYTE SubSec = 0;			// 1=0.2s
bool Flag1Sec = false;
bool ValidTimer;
bool StsPon = false;
bool InTimer = false;

//*******************************************************************************
//
//

void UserInterrupt()
{
	// 200ms
	if(TST_CCP1IF) {
		CLR_CCP1IF;
		SubSec++;
		Flag1 = true;
		if(SubSec == 5) {
			SubSec = 0;
			Flag1Sec = true;		// 1sec
		}
	}

 #asmline SETPCLATH UserIntReturn,-1  ; SETPCLATH for interrupt routine
 #asmline goto UserIntReturn	      ; Assembler - go back to interrupt routine
}



//*******************************************************************************
//
//

void UserInitialise()
{
	BYTE wkb;
	WORD wkw;
	CMCON = 7; 		//disable comparators
	TMR1L = 0;
	TMR1H = 0;

	InitCommFunc();

	if(ReadEEData(0) == 0x12) {
		// EEPROM?????????
		wkw        = ReadEEData(1);			// On-Hour
		wkb        = ReadEEData(2);			// On-Min
		MinStart   = wkw * 60 + wkb;		// ????????

		wkw        = ReadEEData(3);			// Off-Hour
		wkb        = ReadEEData(4);			// Off-Min
		MinEnd     = wkw * 60 + wkb;		// ????????

	} else {
		WriteEEParam(0, 0x12);				// EEPROM???????????

		WriteEEParam(1, 0);					// On-Hour
		WriteEEParam(2, 0);					// On-Min
		WriteEEParam(3, 0);					// Off-Hour
		WriteEEParam(4, 0);					// Off-Min

		MinStart = 0;
		MinEnd = 0;
	}

	GetMinComp();							// ????????

	EI_CCP1;
	EI_PERIP;
	EI_GLOBAL;

}

//*******************************************************************************
//

void UserLoop()
{
	BYTE onsts;
	BYTE cmd, data;

	if(Flag1Sec) {
		Flag1Sec = false;
		UpdateClock();				// ????
		onsts = CompTime();			// ???????
		if(onsts == 1) {
			Pon();
		} else {
			Poff();
		}
	}

	// LED????
	if(Flag1) {
		Flag1 = false;
		// LED??
		if(BlinkCnt >= 0) {
			BlinkCnt = (BlinkCnt+1) % 4;	// 200ms * 4 = 800ms
			if(BlinkCnt == 0) {
				if(LedSts) {
					LED_OFF;
				} else {
					LED_ON;
//					BlinkCnt = 2;			// ON???????
				}
				LedSts = !LedSts;
			}
		}
	}

	// ????????
	if(IrRcvData()) {				// ?????????????
		data = ~IrData >> 4;		// upper4???(??)
		cmd = IrData & 0x0F;		// lower4???

		if(cmd == data) {
			IrCmdExec(cmd);
		}
	}
}


void Pon(void) {
	if(StsPon) {
		return;
	}
	StsPon = true;
	POWER_ON;
	LED_ON;					// LED????
	BlinkCnt = 0;
	LedSts = true;
}

void Poff(void) {
	if(!StsPon) {
		return;
	}
	StsPon = false;
	POWER_OFF;
	LED_OFF;
	BlinkCnt = -1;			// LED????(??)
}


//
// Occurrence - Switch Pressed
//
void PressSw1()
{
	if(!StsPon) {
		Pon();
	} else {
		Poff();
	}
}

void PressSw2()
{
	InTimer = !InTimer;			// ????????/??
	if(InTimer) {
		LED2_ON;				// ??????
	} else {
		LED2_OFF;				// ???????
	}
}

//
// Occurrence - Byte received on serial interface
//
void GetRx()
{
	BYTE rxdata;
	rxdata = WaitRx();
	CmdProc(rxdata);	// ??????,??
}

//
// ?????? ?????????????
//
void SerCmdExec(void) {
	BYTE wkb, wkb2, cmd;
	WORD wkw;
	char buf[8];			// ???????

	cmd = toupper(CmdBuf[0]);
	switch(cmd) {
		case 'T':			// ????????
			if(strlen(CmdBuf) == 7) {
				buf[0] = CmdBuf[1];
				buf[1] = CmdBuf[2];
				buf[2] = 0;
				Hour = atoi(buf);

				buf[0] = CmdBuf[3];
				buf[1] = CmdBuf[4];
				Min = atoi(buf);

				buf[0] = CmdBuf[5];
				buf[1] = CmdBuf[6];
				Sec = atoi(buf);

				// ?????????????
				DI_GLOBAL;
				TMR1L = 0;
				TMR1H = 0;
				SubSec = 0;
				EI_GLOBAL;
				MinClock = (WORD)Hour * 60 + Min;
			} else {
				return;
			}
			break;

		case 'S':			// ??????????
		case 'E':			// ??????????
			if(strlen(CmdBuf) == 5) {
				DI_GLOBAL;
				buf[0] = CmdBuf[1];
				buf[1] = CmdBuf[2];
				buf[2] = 0;
				wkb = atoi(buf);			// on-hour
				wkw = (WORD)wkb * 60;

				buf[0] = CmdBuf[3];
				buf[1] = CmdBuf[4];
				wkb2 = atoi(buf);			// on-min

				if(cmd == 'S') {
					WriteEEParam(4, wkb);
					WriteEEParam(5, wkb2);
					MinStart = wkw + wkb2;
				} else {
					WriteEEParam(6, wkb);
					WriteEEParam(7, wkb2);
					MinEnd = wkw + wkb2;
				}
				EI_GLOBAL;
				GetMinComp();
			} else {
				return;
			}
			break;

		case 'G':			// ??????????
			sprintf(buf, "g%02d:%02d", Hour, Min);
			TxStr(buf);
			sprintf(buf, ":%02d\r\n", Sec);
			TxStr(buf);
			return;


		default:
			TxStr("?\r\n");		// ????????
			return;
	}
	TxStr("OK\r\n");			// ??????(fnprintf NG)
}

//
// ??????????
//
void IrCmdExec(BYTE cmd) {
	switch(cmd) {
//		case 12:			// ON???????
		case 4:			// ON???????
			Pon();
			break;
//		case 13:			// OFF???????
		case 5:			// OFF???????
			Poff();
			break;
//		case 14:			// ????????/??
		case 6:			// ????????/??
			InTimer = !InTimer;
			if(InTimer) {
				LED2_ON;				// ??????
			} else {
				LED2_OFF;				// ???????
			}
			break;
	}
}

