// ???????
// WIZ-C Ver12?  060829

// CCP1 compare mode 10MHz * 1/4 * 1/8 = 312500Hz; t = 3.2us
//    20ms/3.2us = 6250 (CCPR1)
// TIMER2 10MHz x 1/4 * 1/4 * 1/8 = 78125Hz  t = 12.8us

#include "F:\\___CQWORK\\_WizC12Std\\109\\ArSen_Auto.h"
#include <ctype.h>
#include <stdlib.h>
#include <strings.h>
#include "..\\def16f648a.h"
#include "..\\Common\\CommFunc.h"		// ????


// ?????????????????? HS BOD ON
#__config _LVP_OFF&_HS_OSC&_WDT_OFF&_CP_OFF&_BODEN_ON&_PWRTE_ON&_MCLRE_ON

#define BUZZER_ON  PA.B1 = 1		// ?????
#define BUZZER_OFF PA.B1 = 0		// ?????
#define ALM_ON    PA.B2 = 1 		// ???????????
#define ALM_OFF   PA.B2 = 0 		// ?????????????
#define LED_ON    PA.B0 = 1 		// ????????
#define LED_OFF   PA.B0 = 0 		// ????????

#define IrLED_ON   PA.B3 = 1		// ???LED??
#define IrLED_OFF  PA.B3 = 0		// ???LED??

//#define TST_IrIN   PORTA & (1<<4)	// ?????
#define TST_NOLAST (PORTB&(1<<3))					// ???? ?END????
#define TST_ADRS   ((~PORTB>>4)&0x03)		// ???? ????????

// functions
void ResetAlmCounter(void);
void SendData12(int setad);
char IrRcvData12(void);
void AckLedOn(void);
void SetAlerm(char on);

void PulseOut(void);
void Wait480us(void);


WORD Count = 0;

signed char AlmTim;		// ????????????????
signed char AlmCnt;		// ?????????????
signed char BefAlmCnt;	// ??????????????

bool EndSet;
bool RelayMode;
bool Master;
BYTE SetAdrs;
BYTE AdrVal;
//bool KeySense;
//BYTE KeyCode = 0;

BYTE RcvData1, RcvData2;

bool TestMode = true;

BYTE BlkCnt = 0;
bool LedSts = false;
BYTE lc;

signed char LedOffDelay = -1;
signed char BuzOffDelay = -1;

#define DL1 5				// ???????????????(ms)
#define DL2 2				// ????????????????????(ms)

#define ALM_TM_RM 10		// ????????????????????? (x20ms)


//*******************************************************************************
//
//

void UserInterrupt()
{
	// 20ms
	if(TST_CCP1IF) {
		CLR_CCP1IF;
		AlmCnt--;
	}

 #asmline SETPCLATH UserIntReturn,-1  ; SETPCLATH for interrupt routine
 #asmline goto UserIntReturn	      ; Assembler - go back to interrupt routine
}



//*******************************************************************************
//
//

void UserInitialise()
{
	TRISB |= (1<<3);		// RB3 input
	CMCON = 7; //disable comparators
	PORTA = 0;
	PORTB = 0;

	// ???????????
	BUZZER_ON;					// Buzzer ON
	Wait(50);
	BUZZER_OFF;					// Buzzer OFF

	if(TST_NOLAST) {
		EndSet = false;
	} else {
		EndSet = true;
	}

	// ???????????
	AlmTim = ALM_TM_RM;

	SetAdrs = TST_ADRS;			// ???????????????

	if(SetAdrs == 0) {
		// ????#0
		Master = true;
		TestMode = true;		// ?????????????
	} else {
		// ????#1?#3
		Master = false;
		TestMode = false;
	}

	// ???????????????
	AdrVal = (~(SetAdrs << 2) & 0x0C) | SetAdrs;		// b1,b0: adrs / b3,b2: ~adrs

	ResetAlmCounter();

	EI_CCP1;
	EI_PERIP;
	EI_GLOBAL;

	if(Master) {
		// ???
		SendData12(1);			// #1???
		Wait(DL2);				// ????????????????????
	} else {
		// ????
	}


}

//*******************************************************************************
//

void UserLoop()
{
	BYTE adrs;

	if(IrRcvData12()) {
		if((RcvData1 == 0x7F) && (RcvData2 == AdrVal)) {
			// ?????????????
			AckLedOn();
			if(Master) {
				// ???
				ResetAlmCounter();
				Wait(DL1);					// ?????????????????
				SendData12(1);				// #1???
				Wait(DL2);					// ????????????????????
			} else {
				// ????
				Wait(DL1);					// ?????????????????
				if(EndSet) {
					// ???END???????
					SendData12(0);			// #0???
				} else {
					SendData12(SetAdrs + 1);	// ??????????????????(??)
				}
				Wait(DL2);
			}
		}
	}

	// ????20ms?????(????????????????????????)
	if(BefAlmCnt != AlmCnt) {
		BefAlmCnt = AlmCnt;
		// ???????????? ??20ms??
		if(!TestMode) {
			// ??????
			if((AlmCnt <= 0) && Master) {
				// ??????
				SetAlerm(true);
			}
			if(LedOffDelay >= 0) {				// LED ????????
				LedOffDelay--;
				if(LedOffDelay == -1) {
					LED_OFF;					// LED OFF
				}
			}
		} else {
			// ??????(?????)
			// LED????
			BlkCnt++;
			if((BlkCnt & 0x0F) == 0) {
				// 16??1? ->???? 16 * 20 * 2 = 640ms
				if(LedSts) {
					LED_ON;
					LedSts = false;
				} else {
					LED_OFF;
					LedSts = true;
				}
			}
			if(BuzOffDelay >= 0) {				// ???OFF??????
				BuzOffDelay--;
				if(BuzOffDelay == -1) {
					BUZZER_OFF;					// Buz OFF
				}
			}
		}
	}
}


//
// Occurrence - Switch Pressed
//

// ??????????????
void PressSw1()
{
//	TestMode = !TestMode;
	SetAlerm(false);			// ???,ALM??OFF
	TestMode = false;
	LED_OFF;					// ????LED ??
	Wait(500);
	SendData12(1);				// #1???
	ResetAlmCounter();
}


// ????????
void PressSw2()
{
	LED_ON;
	BlkCnt = 0;
	// ???????????
	SetAlerm(false);
	TestMode = true;
	Wait(500);
	SendData12(1);				// #1???
	ResetAlmCounter();
}

void ResetAlmCounter(void) {
	DI_GLOBAL;
	AlmCnt = AlmTim;
	TMR2 = 0;
	EI_GLOBAL;
	#asmline NOP
}


// ???????????????LED??????(??????????)
void AckLedOn(void) {
	if(!TestMode) {
		// ??????
		LedOffDelay = 1;			// 20ms * n
		LED_ON;
	} else {
		// ???????
		BuzOffDelay = 1;			// 20ms * n
//		BUZZER_ON;					// BUZ ON
	}
}


//
//
void SetAlerm(char on) {
	if(on) {
		// ??????????
		BUZZER_ON;				// ???ON
		ALM_ON;					// ALM??ON
	} else {
		// ???????????
		BUZZER_OFF;				// ???OFF
		ALM_OFF;				// ALM??OFF
	}
}


//
// ?????????? 12????
//
void SendData12(int cmd) {
	signed char i, j, ii;
	BYTE data1, data2;

	data1 = 0x7F;		// 01011111

	data2 = (~cmd << 2) & 0x0C;
	data2 |= cmd;		// upper2???????????,lower2????????

	DI_GLOBAL;

	// ------------ H ??? 1440us=480usx3 -----------
	lc = 56;
	PulseOut();
	Wait480us();			// 480us

	// ------------ ?????? D7-D0 -----------------------------
	for(i = 7; i >= 0; i--) {			// upper?????
		if(BitTest(data1, i)) {
			// ??? "1"
			lc = 37;
			PulseOut();
			Wait480us();				// 480us
		} else {
			// ??? "0"
			lc = 19;
			PulseOut();
			Wait480us();				// 480us
		}
	}
	// ------------ ?????? D11-D8 ---------------------------
	for(i = 3; i >= 0; i--) {			// upper?????
		if(BitTest(data2, i)) {
			// ??? "1"
			lc = 37;
			PulseOut();
			Wait480us();				// 480us
		} else {
			// ??? "0"
			lc = 19;
			PulseOut();
			Wait480us();				// 480us
		}
	}

	EI_GLOBAL;
#asmline	NOP
}


//
// 38KHz??????????(Clock=10MHz)
//
void PulseOut(void) {
#asm
LOOP:
	BSF PORTA, 3
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP

	BCF PORTA, 3
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	DECFSZ lc
	GOTO LOOP
#asmend
}

//
// delay 480us(TIMER2??)
//
void Wait480us(void) {
	TMR2 = 0;
	PR2 = 36;			// 480us / 12.8us = 37.5
	CLR_TMR2IF;
	TIMER2_ON;
	while(!TST_TMR2IF) { }
	TIMER2_OFF;
}



// ------------------------------------------------------------------
// ???????? ???????????? (TIMER2??)
//   12????
// ------------------------------------------------------------------
BYTE IrPhase = 0;
BYTE IrBitCnt;
BYTE IrData;
BYTE MajCount;		// 8??????????

char IrRcvData12(void) {
	switch(IrPhase) {
		case 0:			// ?????
			if(TST_IrIN) {
				// ON ????
				TMR2 = 0;
				PR2 = 94;				// 1200us/12.8us
				CLR_TMR2IF;
				TIMER2_ON;				// start
				IrPhase = 1;			// next
			}
			break;

		case 1:			// ??????
			if(TST_IrIN) {
				// ON
				if(TST_TMR2IF) {
					// timeup
					// ???????
					TIMER2_OFF;
					TMR2 = 0;
					//PR2 = 94;			// 1200us/12.8us
					CLR_TMR2IF;
					TIMER2_ON;			// start
					IrPhase = 2;
				}
			} else {
				// ??????????
				TIMER2_OFF;
				IrPhase = 0;			// reset
			}
			break;

		case 2:		// ?????????
			if(TST_TMR2IF) {
				// ??????
				TIMER2_OFF;
				IrPhase = 0;			// reset
			} else {
				if(!TST_IrIN) {
					// OFF
					// ???????????
					TIMER2_OFF;
					// ???????????
					IrData = 0;
					IrBitCnt = 0;
					MajCount = 0;		// 8??????????
					TMR2 = 0;
					PR2 = 47;			// 600us/12.8us
					CLR_TMR2IF;
					TIMER2_ON;			// start
					IrPhase = 3;		// next
				}
			}
			break;

		// ???????????????????(?????????)

		case 3:			//?????????????
			if(TST_TMR2IF) {
				// ???????????
				TIMER2_OFF;
				IrPhase = 0;		// reset
			} else {
				if(TST_IrIN) {
					// ?????
					TIMER2_OFF;
					TMR2 = 0;
					PR2 = 54;				// 700us/12.8us
					CLR_TMR2IF;
					TIMER2_ON;				// start
					IrPhase = 4;			// next
				}
			}
			break;

		case 4:			// ???????????
			if(TST_TMR2IF) {
				// ???????????(?700us??)
				TIMER2_OFF;
				IrData <<= 1;		// ?????????
				if(TST_IrIN) {
					// "1"
					IrData |= 1;
				}
				// ????????????OFF???????
				TMR2 = 0;
				PR2 = 47;			// 600us/12.8us
				CLR_TMR2IF;
				TIMER2_ON;			// start
				IrPhase = 5;
			}
			break;

		case 5:			// ???????OFF???????
			if(TST_TMR2IF) {
				// ??????
				IrPhase = 0;	// ????
			} else {
				if(!TST_IrIN) {			// OFF???????
					IrBitCnt++;				// ?????????
					if(IrBitCnt < 8) {
						// ???8?????
						TMR2 = 0;
						PR2 = 47;			// 600us/12.8us
						CLR_TMR2IF;
						TIMER2_ON;			// start
						IrPhase = 3;		// ????????
					} else {
						MajCount++;
						if(MajCount > 1) {
							// 12????????
							IrPhase = 0;
							RcvData2 = IrData;
							return true;
						} else {
							// 2???????(???4bit)
							RcvData1 = IrData;	// 1?????????????
							IrBitCnt = 4;		// ???4bit?????????
							IrData = 0;			// ??????????

							TMR2 = 0;
							PR2 = 47;			// 600us/12.8us
							CLR_TMR2IF;
							TIMER2_ON;			// start
							IrPhase = 3;		// ????????
						}
					}
				}
			}
			break;
	}
	return false;
}
