#include <P16F648A.h>
#include <P16F648A_bits.h>
#include <PortBits.h>
#include <delays.h>
#include <displays.h>

#define APROCFREQ 4000000

#define BITSIZE 14
#define BOOTADDRESS 0
#define FIRSTRAM 0x20
#define LASTRAM 0x1FF
#define HASOSCCAL 0
#define nPAGESRAM 4
#define nPAGESROM 2
//
// Header file - should be included in all C files used within the program
// This file is created automatically and should not be changed
//

//
// Functions
//
void UserInitialise();			// Your initialisation code
void UserInterrupt();			// Your interrupt code
void UserLoop();			// your Main loop code


#define PortOutnCopy 6
// **********
//
// Port Driver
//
// **********
#define PortOutUsed 1
#define PortOut5Used 1
#define InitialValue5 0
#define Out5Port PORTB
#define Out5Bit 0
// **********
//
// Timer 1
//
// **********
#define Tmr1Used 1
#define EnTimer1 1
#define T1_UseOsc 1
#define SyncT1Inp 1
#define EnT1Osc 0
#define T1_PSD 8
// **********
//
// Port Driver
//
// **********
#define PortOut4Used 1
#define InitialValue4 0
#define Out4Port PORTA
#define Out4Bit 0
// **********
//
// Wait for W milli-seconds
//
// **********
#define WaitWmUsed 1
// **********
//
// Timer 2
//
// **********
#define Tmr2Used 1
#define T2_Post 1
#define T2_Pre 16
#define T2_En 0
// **********
//
// Port Driver
//
// **********
#define PortOut3Used 1
#define InitialValue3 0
#define Out3Port PORTA
#define Out3Bit 4
// **********
//
// Port Driver
//
// **********
#define PortOut2Used 1
#define InitialValue2 0
#define Out2Port PORTA
#define Out2Bit 3
// **********
//
// Port Driver
//
// **********
#define PortOut1Used 1
#define InitialValue1 0
#define Out1Port PORTA
#define Out1Bit 2
// **********
//
// Port Driver
//
// **********
#define PortOut0Used 1
#define InitialValue0 0
#define Out0Port PORTA
#define Out0Bit 1
// **********
//
// Timer 0
//
// **********
#define Tmr0Used 1
void KP4Execute();
#define UsePS 1
#define PSD 4
#define CRE 1
#define UseOsc 1
// **********
//
// Hex keypad
//
// **********
#define KeyPad4x4Used 1
#pragma asmline _KeyPad4x4Used=1
#pragma asmline _KP4PressedUsed=1
#pragma asmline _KP4PressedFlag=Flag1
#pragma asmline _KP4PressedFlagBit=0
#define KP4PressedUsed 1
#define KP4PressedFlag Flag1
#define KP4PressedFlagBit 0
void KeyPress();
#define KP4Debounce 50
#pragma asmline _KP4Debounce=50
#define KP4RepDelay 1000
#pragma asmline _KP4RepDelay=1000
#define KP4RepRate 100
#pragma asmline _KP4RepRate=100
#define KP4ScanDelay 0
#pragma asmline _KP4ScanDelay=0
#define KeyPadRelease 0
#pragma asmline _KeyPadRelease=0
#define Row1Port PORTB
#define Row1Bit 1
#pragma asmline _Row1Port=PORTB
#pragma asmline _Row1Bit=1
#define Row2Port PORTB
#define Row2Bit 2
#pragma asmline _Row2Port=PORTB
#pragma asmline _Row2Bit=2
#define Row3Port PORTB
#define Row3Bit 3
#pragma asmline _Row3Port=PORTB
#pragma asmline _Row3Bit=3
#define Row4Port PORTB
#define Row4Bit 3
#pragma asmline _Row4Port=PORTB
#pragma asmline _Row4Bit=3
#define Col1Port PORTB
#define Col1Bit 4
#pragma asmline _Col1Port=PORTB
#pragma asmline _Col1Bit=4
#define Col2Port PORTB
#define Col2Bit 5
#pragma asmline _Col2Port=PORTB
#pragma asmline _Col2Bit=5
#define Col3Port PORTB
#define Col3Bit 6
#pragma asmline _Col3Port=PORTB
#pragma asmline _Col3Bit=6
#define Col4Port PORTB
#define Col4Bit 7
#pragma asmline _Col4Port=PORTB
#pragma asmline _Col4Bit=7

// **********
//
// Application Designer Variables
//
// **********
extern unsigned char register Flag1;


// Defines specified by 1 or more elements

